from csv import reader
import sys

# USE: python dna.py database.csv sequence.txt

# Ensure correct usage
if len(sys.argv) != 3:
    print("Error. Usage: python dna.py database.csv sequence.txt")

elif len(sys.argv) == 3:

    # 1. Read database people into memory
    with open(sys.argv[1], "r") as file:
        csv_reader = reader(file)

        header = []
        header = next(csv_reader)

        # Store number of STR snips to compare
        nr_of_sequences = len(header)

        rows = []
        for row in csv_reader:
            rows.append(row)

    # 2. Read single given sequence
    with open(sys.argv[2]) as f:
        sequence = f.read()

    # 3. For each STR, compute the longest run of consecutive repeats of it in th DNA sequence

    # for each STR, starting at 1 not 0 (0 is names)
    current_seq = 1

    # create list for results
    results = []

    while current_seq < len(header):
        to_search = header[current_seq]

        # set indexing to 0; indexing to be used for iterating through single DNA sequence one character at a time
        index_into = 0

        # set longest count to 0 for each new STR
        longest_count = 0

        # for each character in the given sequence
        for c in sequence:

            # set a current count of consecutive repeats to 0
            count = 0

            # this is the range to search in the given sequence (starting with 0 to however long the search DNA snip is)
            a = index_into
            b = index_into + len(to_search)
            #print(f"Bits of sequence looking at: {sequence[a:b]}, and we are looking for this from the header file: {header[current_seq]}")

            if sequence[a:b] == to_search:
                count += 1
                found = True
                #print(f"Count: {count}")

                while found == True:
                    # update range
                    a = a + len(to_search)
                    b = b + len(to_search)

                    if sequence[a:b] == to_search:
                        count += 1
                        found = True
                        #print(f"Count: {count}")

                    else:
                        found = False

            # update longest_count to always be the longest sequence
            if count > longest_count:
                longest_count = count

            # move to next character in sequence
            index_into += 1

        # append longest count for consecutive occurrence of this Headerfile-DNA snip to results AS STRING
        results.append(str(longest_count))
        # print(results)

        # move to next STR bit by moving character + 1
        current_seq += 1

    # 3. Compare those counts with every row in the database
    guilty = 0

    for person in rows:
        if person[1:] == results:
            print(person[0])
            guilty = 1

    if guilty != 1:
        print("No match")